"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _components = require("../components");
var _map = require("../constants/map.contstant");
var _GEO = _interopRequireWildcard(require("geolib"));
var _useValidator = _interopRequireDefault(require("../hooks/use-validator"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var _default = props => {
  (0, _useValidator.default)(props);
  const {
    points,
    convertByPoint,
    colorLine = _map.DEFAULT_ACTIVE_COLOR_LINE,
    widthLine = _map.DEFAULT_ACTIVE_COLOR_LINE_WIDTH,
    onEndDraw,
    onStartDraw,
    unitDistance = _map.DEFAULT_UNIT_DISTANCE,
    onChangePoints,
    fillColorCanvas = _map.DEFAULT_FILL_BACKGROUND_CANVAS,
    styleViewGesture,
    backgroundCanvas = _map.DEFAULT_BACKGROUND_VIEW_CANVAS
  } = props;
  const {
    width,
    height
  } = (0, _reactNative.useWindowDimensions)();
  const [containerSize, setContainerSize] = (0, _react.useState)({
    width,
    height
  });
  const containerStyle = (0, _react.useMemo)(() => [{
    zIndex: 1,
    backgroundColor: backgroundCanvas
  }, _reactNative.StyleSheet.absoluteFill, styleViewGesture], [backgroundCanvas, styleViewGesture]);
  const path = (0, _react.useMemo)(() => points.map(item => `${item.x},${item.y}`).join(' '), [points]);
  const calculatedCenterPolygon = coordinates => Promise.resolve(_GEO.getCenter(coordinates));
  const convertPointToCoordinates = (0, _react.useCallback)(polygons => {
    const lengthPolygon = polygons.length;
    if (polygons && lengthPolygon > 0) {
      calculatedCenterPolygon(polygons).then(centerLatLng => {
        if (onEndDraw && centerLatLng) {
          const distance = _GEO.convertDistance(_GEO.getPathLength(polygons), unitDistance);
          const initialLatLng = polygons[_map.DEFAULT_INDEX_INITIAL_LAT_LNG];
          const lastLatLng = polygons[lengthPolygon - 1];
          onEndDraw({
            polygons,
            distance,
            centerLatLng,
            initialLatLng,
            lastLatLng
          });
        }
      });
    }
  }, [onEndDraw, unitDistance]);
  const handleEndDraw = (0, _react.useCallback)(async data => {
    await Promise.all(data.map(convertByPoint)).then(convertPointToCoordinates);
  }, [convertByPoint, convertPointToCoordinates]);
  const handleSetContainerSize = (0, _react.useCallback)(event => {
    setContainerSize({
      width: event.nativeEvent.layout.width,
      height: event.nativeEvent.layout.height
    });
  }, []);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: containerStyle,
    onLayout: handleSetContainerSize
  }, /*#__PURE__*/_react.default.createElement(_components.DrawControl, {
    path: path,
    widthLine: widthLine,
    colorLine: colorLine,
    containerSize: containerSize,
    fillColorCanvas: fillColorCanvas,
    onEndTouchEvents: handleEndDraw,
    onStartTouchEvents: onStartDraw,
    onChangeTouchEvents: onChangePoints
  }));
};
exports.default = _default;
//# sourceMappingURL=maps.js.map